export declare type IDatum<Custom> = {
    value: number;
    children?: Array<IDatum<Custom>>;
} & Custom;
export declare type Input<Custom> = {
    value: number;
    children?: Array<Input<Custom>>;
} & Custom;
export default function <Custom>(data: Array<Input<Custom>>, container: {
    x0: number;
    y0: number;
    x1: number;
    y1: number;
}): ILayoutRect<Custom>[];
export declare type INormalizedDatum<Custom> = IDatum<Custom> & {
    normalizedValue: number;
};
export interface IRect {
    x0: number;
    y0: number;
    x1: number;
    y1: number;
}
export declare type ILayoutRect<T> = IRect & INormalizedDatum<T>;
export declare const calculateMaxAspectRatio: <Custom>(row: INormalizedDatum<Custom>[], length: number) => number;
export declare const doesAddingToRowImproveAspectRatio: <Custom>(currentRow: INormalizedDatum<Custom>[], nextDatum: INormalizedDatum<Custom>, length: number) => boolean;
export declare const normalizeData: <Custom>(data: IDatum<Custom>[], area: number) => INormalizedDatum<Custom>[];
export declare const getCoordinates: <Custom>(row: INormalizedDatum<Custom>[], rect: IRect) => ILayoutRect<Custom>[];
export declare const cutArea: (rect: IRect, area: number) => IRect;
export declare const squarify: <Custom>(inputData: INormalizedDatum<Custom>[], inputCurrentRow: INormalizedDatum<Custom>[], inputRect: IRect, inputStack: ILayoutRect<Custom>[]) => ILayoutRect<Custom>[];
export declare const recurse: <Custom>(datum: ILayoutRect<Custom>) => ILayoutRect<Custom>[];
